<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Display MQTT Data</title>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script> 
  <script src="https://unpkg.com/mqtt/dist/mqtt.min.js"></script>
</head>
<style>
  
  body {
      font-family: Arial, sans-serif;
    }

    .container {
      max-width: 1000px;
      margin: 0 auto;
    }

    h1 {
      text-align: center;
    }

    input[type="date"],
    input[type="text"] {
      width: 100%;
      padding: 0.375rem 0.75rem;
      font-size: 1rem;
      border: 1px solid #ced4da;
      border-radius: 0.25rem;
    }

    .form-group {
      margin-bottom: 1rem;
    }

    .btn-primary {
      width: 100%;
    }

    table {
      width: 100% !important;
      border-collapse: collapse;
      margin-top: 1rem;
    }

    th,
    td {
      border: 1px solid #dee2e6;
    word-wrap: break-word; 
    max-width: 300px;

    }

    th {
      background-color: #f8f9fa;
      font-weight: bold;
    }

    tbody tr:nth-child(even) {
      background-color: #f2f2f2;
    }

    tbody tr:hover {
      background-color: #e2e6ea;
    }
    .textareas{
      width: 600px;
    }
    .send_button{
      background-color: rgb(180, 196, 184);
      font-size: 30px;
      font-weight: 400;
      margin-top: 20px;
      border-radius:7px;
      color: white;
    }
</style>
<body>
  <nav class="navbar navbar-default">
    <div class="container-fluid">
      <div class="navbar-header">
        <a class="navbar-brand" href="#">MQTT Tester</a>
      </div>
      <ul class="nav navbar-nav">
        
        <li><a href="index.html">Send Commands</a></li>
        <li><a href="#">Packet History</a></li>
        
      </ul>
    </div>
  </nav>
  <div class="container mt-5" style="width: 100vw;">
    <div class="card shadow-lg">
    <h1 class="mb-4">MQTT Data</h1>





    <!-- Date -->
    <div class="row m-3">
      <div class="form-group col-md-6">
        <label for="fromDate">From Date:</label>
        <input type="datetime-local" id="fromDate" class="form-control">
      </div>
      <div class="form-group col-md-6">
        <label for="toDate">To Date:</label>
        <input type="datetime-local" id="toDate" class="form-control">
      </div>
    </div>
    
    <!--  filter button -->
    <div class="row m-3">
      <div class="form-group col-md-6">
        <input type="text" id="searchInput" class="form-control mb-3" placeholder="Search By Topic">
      </div>
      <div class="form-group col-md-3">
        <button id="filterButton" class="btn btn-primary mb-3">Filter</button>
      </div>
      <div class="form-group col-md-3">
        <button id="download" onclick="downloadAsCSV()" class="btn btn-primary mb-3">Download Data</button>
      </div>
    </div>
    <!-- Table to display MQTT data -->
    <div class="overflow-auto m-4" style="height: 30rem;">
      <div id="dataContainer">
    </div>
    
      
    </div>
  </div>
  </div>

  <script>
    // Fetch data from the server

        $("#filterButton").click(function(){
          console.log($("#toDate").val().replace("T",":"));
          console.log($("#fromDate").val().replace("T",":"));
          //local
          //$.get("http://localhost:5500/search",{
          //production
          $.get("http://clientmqtt.transight.net:5500/search",{
            fromdate: $("#fromDate").val().replace("T",":"),
            todate: $("#toDate").val().replace("T",":"),
            searchvalue: $("#searchInput").val()
          }, function(data){
            console.log(data);
            $("table").html("");
            generateTable(data);
          });
        
        })
    function generateTable(data) {
      
      if(data.length<1){
        return 0;
      }
      const dataContainer = document.getElementById('dataContainer');
      dataContainer.innerHTML="";
      const table = document.createElement('table');
      table.classList.add('table');
      const thead = document.createElement('thead');
      const tbody = document.createElement('tbody');

        
        const headerRow = document.createElement('tr');
        const headers = Object.keys(data[0]);
        headers.unshift('Serial Number'); 
        headers.forEach(header => {
          const th = document.createElement('th');
          th.textContent = header;
          headerRow.appendChild(th);
        });
        thead.appendChild(headerRow);
        table.appendChild(thead);

    
      const rows = data.map((item, index) => {
        const row = document.createElement('tr');
        const rowData = Object.values(item);
        rowData.unshift(index + 1); 
        rowData.forEach(value => {
          const td = document.createElement('td');
          td.width=100;
          if (typeof value === 'object') {
            
            td.textContent = JSON.stringify(value);
           
          } else {
            td.textContent = value;
          }
         
          row.appendChild(td);
        });
        return row;
      });
      tbody.append(...rows);
      table.appendChild(tbody);

      if (dataContainer.firstChild) {
        dataContainer.replaceChild(table, dataContainer.firstChild);
      } else {
        dataContainer.appendChild(table);
      }
    }
    function downloadAsCSV() {
    const table = document.getElementsByClassName('table');
    const csv = [];
    console.log(table[0])
    for (let i = 0; i < table[0].rows.length; i++) {
        const row = table[0].rows[i];
        const rowData = [];
        for (let j = 0; j < row.cells.length; j++) {
            rowData.push(row.cells[j].innerText);
        }
        csv.push(rowData.join(','));
    }
    const csvContent = 'data:text/csv;charset=utf-8,' + csv.join('\n');
    const encodedUri = encodeURI(csvContent);
    const link = document.createElement('a');
    link.setAttribute('href', encodedUri);
    link.setAttribute('download', 'table.csv');
    document.body.appendChild(link);
    link.click();
}
  </script>
</body>
</html>
